skip to navigation
skip to content

meta-package-manager 2.5.0

CLI providing unifying interface to all package managers.

CLI providing unifying interface to all package managers.

Stable release:

Development:

Source: XKCD #1654.

Features

  • Search and list all package managers on the system.
  • Supports macOS and Linux.
  • List installed packages.
  • Search for packages.
  • List outdated packages.
  • Sync local package infos.
  • Upgrade all outdated packages.
  • Apply commands per-package manager or to all of them.
  • Export results in JSON or user-friendly tables.
  • Provides a BitBar plugin for friendly macOS integration.

Supported package managers

Package manager Version macOS Linux Windows sync installed search install outdated upgrade
Homebrew >= 1.0.*      
Homebrew Cask >= 1.0.*      
Python 2 pip        
Python 3 pip        
Node’s npm >= 4.0.*      
Atom’s apm        
Ruby’s gem        
Mac AppStore via mas >= 1.3.1        

If you’re bored, feel free to add support for new package manager. See the list of good candidates.

Usage

Examples of the package’s mpm CLI.

List global options and commands:

$ mpm
Usage: mpm [OPTIONS] COMMAND [ARGS]...

  CLI for multi-package manager upgrades.

Options:
  -v, --verbosity LEVEL           Either CRITICAL, ERROR, WARNING, INFO or
                                  DEBUG. Defaults to INFO.
  -m, --manager [npm|mas|pip3|pip2|cask|apm|brew|gem]
                                  Restrict sub-command to one package manager.
                                  Defaults to all.
  -o, --output-format [simple|plain|json|fancy]
                                  Rendering mode of the output. Defaults to
                                  fancy.
  --version                       Show the version and exit.
  --help                          Show this message and exit.

Commands:
  managers  List supported package managers and their location.
  outdated  List outdated packages.
  sync      Sync local package info.
  upgrade   Upgrade all packages.

List all supported package managers and their status on current system:

$ mpm managers
╒═══════════════════╤══════╤═════════════╤════════════════════════╤══════════════╤═════════════╕
│ Package manager   │ ID   │ Supported   │ CLI                    │ Executable   │ Version     │
╞═══════════════════╪══════╪═════════════╪════════════════════════╪══════════════╪═════════════╡
│ Atom's apm        │ apm  │ ✓           │ ✓  /usr/local/bin/apm  │ ✓            │ ✓  1.12.9   │
├───────────────────┼──────┼─────────────┼────────────────────────┼──────────────┼─────────────┤
│ Homebrew          │ brew │ ✓           │ ✓  /usr/local/bin/brew │ ✓            │ ✓  1.1.7    │
├───────────────────┼──────┼─────────────┼────────────────────────┼──────────────┼─────────────┤
│ Homebrew Cask     │ cask │ ✓           │ ✓  /usr/local/bin/brew │ ✓            │ ✓  1.1.7    │
├───────────────────┼──────┼─────────────┼────────────────────────┼──────────────┼─────────────┤
│ Ruby Gems         │ gem  │ ✓           │ ✓  /usr/bin/gem        │ ✓            │ ✓  2.0.14.1 │
├───────────────────┼──────┼─────────────┼────────────────────────┼──────────────┼─────────────┤
│ Mac AppStore      │ mas  │ ✓           │ ✓  /usr/local/bin/mas  │ ✓            │ ✓  1.3.1    │
├───────────────────┼──────┼─────────────┼────────────────────────┼──────────────┼─────────────┤
│ Node's npm        │ npm  │ ✓           │ ✓  /usr/local/bin/npm  │ ✓            │ ✓  4.0.5    │
├───────────────────┼──────┼─────────────┼────────────────────────┼──────────────┼─────────────┤
│ Python 2's Pip    │ pip2 │ ✓           │ ✓  /usr/local/bin/pip2 │ ✓            │ ✓  9.0.1    │
├───────────────────┼──────┼─────────────┼────────────────────────┼──────────────┼─────────────┤
│ Python 3's Pip    │ pip3 │ ✓           │ ✓  /usr/local/bin/pip3 │ ✓            │ ✓  9.0.1    │
╘═══════════════════╧══════╧═════════════╧════════════════════════╧══════════════╧═════════════╛

Changes for v2.5.0 (2017-03-01)

  • Auto-detect location of manager CLI on the system.
  • Add new search operation. Closes #22.
  • Bump minimal requirement of npm to 4.0.*.
  • Rename list operation to installed.
  • Allow use of gem, npm and apm managers on Linux.
  • Add new --stats/--no-stats boolean flags. Closes #8.
  • Add new --stop-on-error/--continue-on-error parameters to make CLI errors either blocking or non-blocking.
  • Allow reporting of several CLI errors by managers.
  • Allow selection of a subset of managers.
  • Do not force a sync before listing installed packages in CLI.
  • Rework API documentation.
  • Add unittest to cover unicode names for Cask packages. Closes #16.
  • Add unittest to cover Cask packages with multiple names. Refs #26.
  • Drop support of Python 3.3.

Full changelog.

 
File Type Py Version Uploaded on Size
meta-package-manager-2.5.0.tar.gz (md5) Source 2017-03-01 1MB
meta_package_manager-2.5.0-py2.7.egg (md5) Python Egg 2.7 2017-03-01 43KB
meta_package_manager-2.5.0-py2.py3-none-any.whl (md5) Python Wheel 2.7 2017-03-01 47KB